### org.jfree.layouting.renderer.process

# Class ComputeStaticPropertiesStep

- `java.lang.Object`
- - `org.jfree.layouting.renderer.process.IterateVisualProcessStep`
  - - `org.jfree.layouting.renderer.process.ComputeStaticPropertiesStep`

`public class ComputeStaticPropertiesStep`
`extends IterateVisualProcessStep`

This step computes the defined margins, the border and paddings. Before margins and borders can be computed, this derives the block-context-width.

The block-context-width is a precomputed value and defaults to the total page width (or when there is no such width, a predefined value). The block-context-width is independent of the final size of the element.

Table-Cells establish their own context, if the width is known. (This adds the dependency, that the table structure must be validated before the static properties can be computed.) If the width is not known, the block-context-width will be undefined (zero) unless a new known context gets established.

Author:
  Thomas Morgner

  ## Constructor Summary

  `ComputeStaticPropertiesStep()`

  ## Method Summary

  `void`

  `compute(LogicalPageBox root)`

  `protected RenderLength`

  `computeBlockContextWidth(RenderNode node)`

  `protected void`

  `processBlockLevelNode(RenderNode node)`

  `protected void`

  `processInlineLevelNode(RenderNode node)`

  `protected void`

  `processParagraphChilds(ParagraphRenderBox box)`

  `protected boolean`

  `startBlockLevelBox(RenderBox box)`

  `protected boolean`

  `startInlineLevelBox(RenderBox box)`

  ### Methods inherited from class org.jfree.layouting.renderer.process.IterateVisualProcessStep

  `finishBlockLevelBox`, `finishInlineLevelBox`, `processBlockLevelChild`, `processBlockLevelNode`, `processBoxChilds`, `processFlow`, `processInlineLevelChild`, `processInlineLevelNode`, `processOtherLevelChild`, `processParagraphChilds`, `startBlockLevelBox`, `startInlineLevelBox`, `startProcessing`

## Constructor Details

### ComputeStaticPropertiesStep

    public ComputeStaticPropertiesStep()

## Method Details

### compute

    public void compute(LogicalPageBox root)

### computeBlockContextWidth

    protected RenderLength computeBlockContextWidth(RenderNode node)

### processBlockLevelNode

    protected void processBlockLevelNode(RenderNode node)

> Overrides:
>   processBlockLevelNode in interface IterateVisualProcessStep

### processInlineLevelNode

    protected void processInlineLevelNode(RenderNode node)

> Overrides:
>   processInlineLevelNode in interface IterateVisualProcessStep

### processParagraphChilds

    protected void processParagraphChilds(ParagraphRenderBox box)

> Overrides:
>   processParagraphChilds in interface IterateVisualProcessStep

### startBlockLevelBox

    protected boolean startBlockLevelBox(RenderBox box)

> Overrides:
>   startBlockLevelBox in interface IterateVisualProcessStep

### startInlineLevelBox

    protected boolean startInlineLevelBox(RenderBox box)

> Overrides:
>   startInlineLevelBox in interface IterateVisualProcessStep